<?php
namespace org\standard\aps\types\core\resource;
class Counter {
/**
 * @type(integer)
 */
public $usage;
/**
 * @type(integer)
 */
public $limit;

}
class Limit {
/**
 * @type(integer)
 */
public $limit;

}
class Usage {
/**
 * @type(integer)
 */
public $usage;

}
class NotificationSource {
/**
 * @type(string)
 * @format("uri")
 * @description("APS Type of source resources")
 */
public $type;
/**
 * @type(string)
 * @description("Resource which is source of event")
 */
public $id;

}
class Notification {
/**
 * @type(string)
 * @required
 * @format("uri")
 * @description("Type of event (URI)")
 */
public $type;
/**
 * @type(string)
 * @format("date-time")
 * @description("Date-time when event happens")
 */
public $time;
/**
 * @type(number)
 * @description("Serial number of event (incrementing)")
 */
public $serial;
/**
 * @type(\org\standard\aps\types\core\resource\NotificationSource)
 * @description("Resource originating the event")
 */
public $source;

}
/**
 * Class Resource
 * @id("http://aps-standard.org/types/core/resource/1.0")
 * @structure(Counter)
 * @structure(Limit)
 * @structure(Usage)
 * @structure(NotificationSource)
 * @structure(Notification)
 */
class Resource extends \APS\ResourceBase
{

/**
 * @verb(POST)
 * @path("/")
 * @static
 */
public function provision() {
	return \APS\Request::getController()->getIo()->sendRequest("POST", \APS\Proto::resourcePath($this->aps->id, "/"));
}

/**
 * @verb(GET)
 * @path("/")
 */
public function retrieve() {
	return \APS\Request::getController()->getIo()->sendRequest("GET", \APS\Proto::resourcePath($this->aps->id, "/"));
}

/**
 * @verb(PUT)
 * @path("/")
 * @param(self, body)
 */
public function configure($new) {
	return \APS\Request::getController()->getIo()->sendRequest("PUT", \APS\Proto::resourcePath($this->aps->id, "/"), $new);
}

/**
 * @verb(DELETE)
 * @path("/")
 */
public function unprovision() {
	return \APS\Request::getController()->getIo()->sendRequest("DELETE", \APS\Proto::resourcePath($this->aps->id, "/"));
}
}
?>