<?php
namespace org\standard\aps\types\core\subscription;
class SubscriptionResource {
/**
 * @type(string)
 * @required
 */
public $id;
/**
 * @type(string)
 */
public $title;
/**
 * @type(string)
 */
public $apsId;
/**
 * @type(string)
 */
public $apsType;
/**
 * @type(string)
 */
public $property;
/**
 * @type(integer)
 */
public $usage;
/**
 * @type(integer)
 */
public $limit;
/**
 * @type(string)
 * @required
 * @pattern("unit|b|kb|mb|gb|.*")
 */
public $unit;

}
/**
 * Class Subscription
 * @id("http://aps-standard.org/types/core/subscription/1.0")
 * @structure(SubscriptionResource)
 */
class Subscription extends \APS\ResourceBase
{
/**
 * @type(boolean)
 */
public $trial;
/**
 * @type(boolean)
 */
public $disabled;

/**
 * @verb(GET)
 * @path("/resources")
 * @return(SubscriptionResource[])
 */
public function resources() {
	return \APS\Request::getController()->getIo()->sendRequest("GET", \APS\Proto::resourcePath($this->aps->id, "/resources"));
}
}
?>