<?php
namespace org\standard\aps\types\infrastructure\environment;
class OS {
/**
 * @type(string)
 * @pattern("Windows|Linux|MacOS|.+")
 * @description("Operating system name")
 */
public $type;
/**
 * @type(string)
 * @pattern("redhat|centos|debian|ubuntu|cloudlinux|.+")
 * @description("Operation system distribution")
 */
public $name;
/**
 * @type(string)
 * @pattern("datacenter|server|desktop|.*")
 * @description("Operation system edition")
 */
public $edition;
/**
 * @type(number)
 * @description("Operation system Version in format <major>.<minor>")
 */
public $version;

}
class CPU {
/**
 * @type(integer)
 * @description("Number of CPUcores")
 */
public $number;
/**
 * @type(number)
 * @description("CPU Power in  MHz")
 */
public $power;

}
class Platform {
/**
 * @type(string)
 * @pattern("x86|x86_64|ia64|arm|.+")
 * @description("System architecture")
 */
public $arch;
/**
 * @type(\org\standard\aps\types\infrastructure\environment\OS)
 * @description("System operating system")
 */
public $os;

}
class Hardware {
/**
 * @type(integer)
 * @description("Bandwidth in Mbps")
 * @unit("mbps")
 */
public $bandwidth;
/**
 * @type(\org\standard\aps\types\infrastructure\environment\CPU)
 */
public $cpu;
/**
 * @type(integer)
 * @description("Disk space in Mbytes")
 * @unit("mb")
 */
public $diskspace;
/**
 * @type(integer)
 * @description("Memory size in Mbytes")
 * @unit("mb")
 */
public $memory;

}
/**
 * Class Environment
 * @id("http://aps-standard.org/types/infrastructure/environment/1.0")
 * @structure(OS)
 * @structure(CPU)
 * @structure(Platform)
 * @structure(Hardware)
 */
class Environment extends \APS\ResourceBase
{
/**
 * @type(string)
 * @description("Application access point")
 */
public $entryPoint;
/**
 * @type(string[])
 */
public $engines;
/**
 * @type(\org\standard\aps\types\infrastructure\environment\Hardware)
 */
public $hardware;
/**
 * @type(\org\standard\aps\types\infrastructure\environment\Platform)
 */
public $platform;
/**
 * @link("http://aps-standard.org/types/core/application/1.0")
 */
public $application;
}
?>