<?php
namespace org\standard\aps\types\web\website;
class User {
/**
 * @type(string)
 */
public $name;
/**
 * @type(string)
 * @encrypted
 */
public $password;

}
/**
 * Class Website
 * @id("http://aps-standard.org/types/web/website/1.0")
 * @implements("http://aps-standard.org/types/core/resource/1.0")
 * @structure(User)
 */
class Website extends \APS\ResourceBase
{
/**
 * @type(string)
 * @required
 */
public $path;
/**
 * @type(string[])
 * @required
 * @minItems(1)
 */
public $urls;
/**
 * @link("http://aps-standard.org/types/ip-address/1.0[]")
 */
public $ipAddress;
/**
 * @link("http://aps-standard.org/types/dns/domain/1.0")
 */
public $domain;
/**
 * @link("http://aps-standard.org/types/web/ssl-certificate/1.0")
 */
public $sslCertificate;

/**
 * @verb(GET)
 * @path("/users/{protocol}")
 * @access(referrer,true)
 * @return(string[])
 * @param(string, path)
 */
public function getUsers($protocol) {
	return \APS\Request::getController()->getIo()->sendRequest("GET", \APS\Proto::resourcePath($this->aps->id, "/users/{protocol}"));
}

/**
 * @verb(POST)
 * @path("/users/{protocol}")
 * @access(referrer,true)
 * @return(User)
 * @param(string, path)
 * @param(User, body)
 */
public function addUser($protocol, $user) {
	return \APS\Request::getController()->getIo()->sendRequest("POST", \APS\Proto::resourcePath($this->aps->id, "/users/{protocol}"), $user);
}

/**
 * @verb(PUT)
 * @path("/users/{protocol}/{name}")
 * @access(referrer,true)
 * @param(string, path)
 * @param(string, path)
 * @param(User, body)
 */
public function setUser($protocol, $name, $password) {
	return \APS\Request::getController()->getIo()->sendRequest("PUT", \APS\Proto::resourcePath($this->aps->id, "/users/{protocol}/{name}"), $password);
}

/**
 * @verb(DELETE)
 * @path("/users/{protocol}/{name}")
 * @access(referrer,true)
 * @param(string, path)
 * @param(string, path)
 */
public function deleteUser($protocol, $name) {
	return \APS\Request::getController()->getIo()->sendRequest("DELETE", \APS\Proto::resourcePath($this->aps->id, "/users/{protocol}/{name}"));
}
}
?>